clang 10.0.0git

Public Types | Public Member Functions | List of all members
clang::ento::retaincountchecker::RefCountBug Class Reference

`#include "/work/www-prereleases/10.0.0/rc1/docsbuild/clang/lib/StaticAnalyzer/Checkers/RetainCountChecker/RetainCountDiagnostics.h"`

Inheritance diagram for clang::ento::retaincountchecker::RefCountBug:
[legend]
Collaboration diagram for clang::ento::retaincountchecker::RefCountBug:
[legend]

## Public Types
enum | RefCountBugType { UseAfterRelease, ReleaseNotOwned, DeallocNotOwned, FreeNotOwned, OverAutorelease, ReturnNotOwnedForOwned, LeakWithinFunction, LeakAtReturn }

## Public Member Functions
| RefCountBug (const CheckerBase *checker, RefCountBugType BT)
StringRef | getDescription () const
RefCountBugType | getBugType () const
const CheckerBase * | getChecker () const
Public Member Functions inherited from clang::ento::BugType
| BugType (CheckerNameRef CheckerName, StringRef Name, StringRef Cat, bool SuppressOnSink=false)
| BugType (const CheckerBase *Checker, StringRef Name, StringRef Cat, bool SuppressOnSink=false)
virtual | ~BugType ()=default
StringRef | getDescription () const
StringRef | getCategory () const
StringRef | getCheckerName () const
bool | isSuppressOnSink () const
| isSuppressOnSink - Returns true if bug reports associated with this bug type should be suppressed if the end node of the report is post-dominated by a sink node. More...

## Detailed Description

Definition at line 27 of file RetainCountDiagnostics.h.

## Member Enumeration Documentation

## ◆ RefCountBugType

enum clang::ento::retaincountchecker::RefCountBug::RefCountBugType

Enumerator
UseAfterRelease |
ReleaseNotOwned |
DeallocNotOwned |
FreeNotOwned |
OverAutorelease |
ReturnNotOwnedForOwned |
LeakWithinFunction |
LeakAtReturn |

Definition at line 29 of file RetainCountDiagnostics.h.

## Constructor & Destructor Documentation

## ◆ RefCountBug()

RefCountBug::RefCountBug | ( | const CheckerBase * | checker,
|  | RefCountBugType | BT
| ) |  |

Definition at line 66 of file RetainCountDiagnostics.cpp.

## Member Function Documentation

## ◆ getBugType()

RefCountBugType clang::ento::retaincountchecker::RefCountBug::getBugType | ( |  | ) | const
| inline

Definition at line 42 of file RetainCountDiagnostics.h.

## ◆ getChecker()

const CheckerBase* clang::ento::retaincountchecker::RefCountBug::getChecker | ( |  | ) | const
| inline

Definition at line 46 of file RetainCountDiagnostics.h.

## ◆ getDescription()

StringRef RefCountBug::getDescription | ( |  | ) | const

Definition at line 43 of file RetainCountDiagnostics.cpp.

References DeallocNotOwned, FreeNotOwned, LeakAtReturn, LeakWithinFunction, OverAutorelease, ReleaseNotOwned, ReturnNotOwnedForOwned, and UseAfterRelease.

The documentation for this class was generated from the following files:

- lib/StaticAnalyzer/Checkers/RetainCountChecker/RetainCountDiagnostics.h
- lib/StaticAnalyzer/Checkers/RetainCountChecker/RetainCountDiagnostics.cpp